 

ORG 6639 
'Indts basic-bl
'print usr(6639)

DB $0F,$0A,$0,$DD 
DB " USR" 
DB $96 
DB "7000" 
DB $95,$FF 
DS 346,$0 


JP @INIT 



COLOR_BLACK: EQU 0 
COLOR_DARKBLUE: EQU 1 
COLOR_DARKRED: EQU 4 
COLOR_DARKMAGENTA: EQU 5 
COLOR_DARKGREEN: EQU 16 
COLOR_DARKCYAN: EQU 17 
COLOR_DARKYELLOW: EQU 20 
COLOR_GRAY: EQU 21 
COLOR_BLACK2: EQU 64 
COLOR_BLUE: EQU 65 
COLOR_RED: EQU 68 
COLOR_MAGENTA: EQU 69 
COLOR_GREEN: EQU 80 
COLOR_CYAN: EQU 81 
COLOR_YELLOW: EQU 84 
COLOR_WHITE: EQU 85 

BORDER_BLACK: EQU 0 
BORDER_DARKBLUE: EQU 2 
BORDER_DARKRED: EQU 8 
BORDER_DARKMAGENTA: EQU 10 
BORDER_DARKGREEN: EQU 32 
BORDER_DARKCYAN: EQU 34 
BORDER_DARKYELLOW: EQU 40 
BORDER_GRAY: EQU 42 
BORDER_BLACK2: EQU 128 
BORDER_BLUE: EQU 130 
BORDER_RED: EQU 138 
BORDER_MAGENTA: EQU 138 
BORDER_GREEN: EQU 160 
BORDER_CYAN: EQU 162 
BORDER_YELLOW: EQU 168 
BORDER_WHITE: EQU 170 

GRAPHICS2: EQU 0 
GRAPHICS4: EQU 1 
GRAPHICS16: EQU 2 

PALETTE_0_PORT: EQU $60 
PALETTE_1_PORT: EQU $61 
PALETTE_2_PORT: EQU $62 
PALETTE_3_PORT: EQU $63 




P_SAVE: EQU 3 
MEM_PAGES_PORT: EQU 2 
GRAPH_MODE: EQU $0B13 
GRAPHICS_MODE_PORT: EQU 6 
BORDER: EQU $0B4F 
BORDER_PORT: EQU $0 
OS_TIMER: EQU 2845 

KEYBOARD_0: EQU 2897 
KEYBOARD_1: EQU 2898 
KEYBOARD_2: EQU 2899 
KEYBOARD_3: EQU 2900 
KEYBOARD_4: EQU 2901 
KEYBOARD_5: EQU 2902 
KEYBOARD_6: EQU 2903 
KEYBOARD_7: EQU 2904 
JOY1_STATE: EQU 2905 
JOY2_STATE: EQU 2906 

JOY_LEFT: EQU 64 
JOY_RIGHT: EQU 32 
JOY_DOWN: EQU 4 
JOY_UP: EQU 1 
JOY_FIRE: EQU 8 

KEY_RETURN: EQU 16 

VRAM_START: EQU $8000 
LEVEL_VRAM_START: EQU $8000 
SCREEN_WIDTH: EQU 64 




H_TILES: EQU 16 
V_TILES: EQU 8 
SCREEN_TILES: EQU 128
LEVEL_TILES: EQU 128

TILE_WIDTH: EQU 4 
TILE_HEIGHT: EQU 16 
TILE_SIZE: EQU 64

NO_SCROLL: EQU 0
LEFT: EQU 1 
RIGHT: EQU 2



SAVED_MEM_PAGES:
DB 0 
SAVED_GRAPH_MODE:
DB 0 

LEVEL_OFFSET:
DW 0 
SCROLL_DIRECTION:
DB 0



INIT:
 LD A,(@P_SAVE) 
LD (@SAVED_MEM_PAGES),A 
LD A,(@GRAPH_MODE) 
LD (@SAVED_GRAPH_MODE),A 

LD A,(@GRAPH_MODE) 
AND 252
OR 2
LD (@GRAPH_MODE),A 
OUT (@GRAPHICS_MODE_PORT),A 
LD A,128
LD (@BORDER),A 

CALL @CLEAR_SCREEN 
CALL @VIDON 
CALL @FIRST_DRAW_LEVEL 



MAIN_LOOP:
 LD A,(2902) 
CP 16
JP Z,@THE_END 
LD A,(@JOY1_STATE) 
CP 32
JP Z,@SCROLL_RIGHT 
CP 64
JP Z,@SCROLL_LEFT 
JP @MAIN_LOOP 



SCROLL_RIGHT:
'*break
 LD HL,(@LEVEL_OFFSET) 
LD A,H 
CP 2 
JP Z,@MAIN_LOOP 
LD BC,8
ADD HL,BC 
LD (@LEVEL_OFFSET),HL 
LD HL,@SCROLL_DIRECTION
LD (HL),@RIGHT 
CALL @DRAW_LEVEL 
JP @MAIN_LOOP 



SCROLL_LEFT:
 LD HL,(@LEVEL_OFFSET) 
LD A,H 
OR A 
JP NZ,@LEFT_MOVE 
LD A,L 
OR A 
JP Z,@MAIN_LOOP 
LEFT_MOVE:
 LD BC,@V_TILES 
OR A 
SBC HL,BC 
LD (@LEVEL_OFFSET),HL 
LD HL,@SCROLL_DIRECTION 
LD (HL),@LEFT 
CALL @DRAW_LEVEL 
JP @MAIN_LOOP 



DRAW_LEVEL:
 LD HL,@LEVEL1_MAP 
LD BC,(@LEVEL_OFFSET) 
ADD HL,BC 
LD DE,@LEVEL_VRAM_START 
LD B,@H_TILES 
HALT 
DRAW_LEVEL_COLS:
 PUSH BC 
PUSH DE 
PUSH HL 
LD BC,@V_TILES 
LD A,(@SCROLL_DIRECTION) 
CP @LEFT 
JP Z,@SET_IX_TO_L_SCROLL 
OR A 
SBC HL,BC 
JP @INIT_DRAW 
SET_IX_TO_L_SCROLL:
 ADD HL,BC 
INIT_DRAW:
 PUSH HL 
POP IX 
POP HL 

LD B,@V_TILES 
DRAW_LEVEL_ROW:
 PUSH BC 
LD A,(HL) 
CP (IX+0) 
JP NZ,@INIT_TILE_DRAW 
LD BC,1024
EX DE,HL 
ADD HL,BC 
EX DE,HL 
JP @NEXT_TILE 

INIT_TILE_DRAW:
 PUSH HL 
LD HL,@TILE_SPRITES 
OR A 
JP Z,@DRAW_TILE 
LD BC,@TILE_SIZE 
SET_TILE:
 ADD HL,BC 
DEC A 
JP NZ,@SET_TILE 
DRAW_TILE:
 LD A,@TILE_HEIGHT 
DRAW_TILE_ITER:
 LD BC,@SCREEN_WIDTH 
LDI 
LDI 
LDI 
LDI 
EX DE,HL 
ADD HL,BC 
EX DE,HL 
DEC A 
JP NZ,@DRAW_TILE_ITER 
POP HL 

NEXT_TILE:
 INC HL 
INC IX 
POP BC 
DJNZ @DRAW_LEVEL_ROW 

POP DE 
INC DE 
INC DE 
INC DE 
INC DE 
POP BC 
DJNZ @DRAW_LEVEL_COLS 
RET 



FIRST_DRAW_LEVEL:
 LD HL,@LEVEL1_MAP 
LD BC,(@LEVEL_OFFSET) 
ADD HL,BC 
LD DE,@LEVEL_VRAM_START 
LD B,@H_TILES 
FDRAW_LEVEL_ITER:
 PUSH BC 
PUSH DE 
LD B,@V_TILES 
FDRAW_LEVEL_ROW:
 PUSH BC 
LD A,(HL) 
PUSH HL 
LD HL,@TILE_SPRITES 
OR A 
JP Z,@FDRAW_TILE 
LD BC,@TILE_SIZE 
FSET_TILE:
 ADD HL,BC 
DEC A 
JP NZ,@FSET_TILE 
FDRAW_TILE:
 LD A,@TILE_HEIGHT 
FDRAW_TILE_ITER:
 LD BC,@SCREEN_WIDTH 
LDI 
LDI 
LDI 
LDI 
EX DE,HL 
ADD HL,BC 
EX DE,HL 
DEC A 
JP NZ,@FDRAW_TILE_ITER 
POP HL 
INC HL 
INC IX 
POP BC 
DJNZ @FDRAW_LEVEL_ROW 
POP DE 
INC DE 
INC DE 
INC DE 
INC DE 
POP BC 
DJNZ @FDRAW_LEVEL_ITER 
RET 



THE_END:
 CALL @VIDOFF 
LD A,(@SAVED_GRAPH_MODE) 
LD (@GRAPH_MODE),A 
OUT (@GRAPHICS_MODE_PORT),A 
LD HL,0 
RET 



VIDON:
 LD A,$50 
LD (@P_SAVE),A 
OUT (@MEM_PAGES_PORT),A 
RET 



VIDOFF:
 LD A,(@SAVED_MEM_PAGES) 
LD (@P_SAVE),A 
OUT (@MEM_PAGES_PORT),A 
RET 



CLEAR_SCREEN:
 RST $30 
DB $5 
RET 



WAITFORANYKEY:
 RST $30 
DB $91 
RET 



LEVEL1_MAP:
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 9,11,0,0,0,0,0,1 
DB 10,12,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,2,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,3,0,0,0,1 
DB 0,0,0,2,0,0,0,1 
DB 0,0,0,3,0,0,0,1 
DB 0,0,0,2,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 

DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,4,6,1 
DB 0,9,11,0,0,5,7,1 
DB 0,10,12,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 9,11,0,0,0,0,0,1 
DB 10,12,0,0,4,6,6,1 
DB 0,0,0,0,5,7,7,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 

DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,4,6,1 
DB 0,0,0,0,0,5,7,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,3,0,0,1 
DB 0,0,0,0,2,0,0,1 
DB 0,0,0,0,3,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,3,0,0,0,1 
DB 0,0,0,3,0,0,0,1 
DB 0,0,0,3,0,0,0,0 
DB 9,11,0,0,0,0,0,0 
DB 10,12,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 

DB 0,0,0,0,3,0,0,1 
DB 0,0,0,0,2,0,0,1 
DB 0,0,0,0,3,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,0 
DB 0,0,3,0,0,0,0,0 
DB 0,0,0,0,0,0,0,0 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,3,0,0,0,0,1 
DB 0,0,2,0,3,0,0,1 

DB 0,0,0,0,2,0,0,1 
DB 0,0,0,0,3,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,8,1 
DB 0,0,0,0,0,8,8,1 
DB 0,0,0,0,8,8,8,1 
DB 0,0,0,0,0,0,0,0 
DB 0,0,0,0,0,0,0,0 
DB 0,0,0,0,8,8,8,1 
DB 0,0,0,0,0,8,8,1 
DB 9,11,0,0,0,0,8,1 
DB 10,12,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 
DB 0,0,0,0,0,0,0,1 



TILE_SPRITES:
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 

FLOOR:
DB 252,252,252,168 
DB 84,204,84,136 
DB 84,204,84,136 
DB 84,204,84,136 
DB 84,204,84,136 
DB 84,204,0,0 
DB 84,204,84,168 
DB 84,204,84,136 
DB 84,204,84,136 
DB 84,136,236,136 
DB 168,136,236,136 
DB 252,0,236,136 
DB 236,168,236,136 
DB 236,136,236,136 
DB 0,68,0,68 
DB 252,252,92,252 

QUESTION:
DB 204,204,204,204 
DB 220,252,252,168 
DB 220,252,252,168 
DB 220,236,220,168 
DB 220,220,236,168 
DB 220,220,236,168 
DB 220,252,236,168 
DB 220,252,236,168 
DB 220,252,220,168 
DB 220,252,220,168 
DB 220,252,220,168 
DB 220,252,252,168 
DB 220,252,220,168 
DB 220,252,252,168 
DB 220,252,252,168 
DB 0,0,0,0 

BRICKWALL:
DB 204,136,204,136 
DB 204,136,204,136 
DB 204,136,204,136 
DB 0,0,0,0 
DB 136,204,136,204 
DB 136,204,136,204 
DB 136,204,136,204 
DB 0,0,0,0 
DB 204,136,204,136 
DB 204,136,204,136 
DB 204,136,204,136 
DB 0,0,0,0 
DB 136,204,136,204 
DB 136,204,136,204 
DB 136,204,136,204 
DB 0,0,0,0 

CHIMNEY_TL:
DB 0,0,0,0 
DB 80,240,240,240 
DB 16,112,176,48 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 80,112,176,240 
DB 0,0,0,0 
DB 162,0,0,0 

CHIMNEY_TR:
DB 0,0,0,0 
DB 240,240,240,160 
DB 48,48,48,32 
DB 48,48,176,160 
DB 48,48,112,160 
DB 48,48,176,160 
DB 48,48,112,160 
DB 48,48,176,160 
DB 48,48,112,160 
DB 48,48,176,160 
DB 48,48,112,160 
DB 48,48,176,160 
DB 48,48,112,160 
DB 48,48,176,160 
DB 0,0,0,0 
DB 0,0,0,81 

CHIMNEY_BL:
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 
DB 162,176,240,112 

CHIMNEY_BR:
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 
DB 48,48,240,81 
DB 48,112,112,81 

STONE:
DB 221,255,255,170 
DB 221,255,255,170 
DB 238,255,255,0 
DB 238,255,255,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 255,204,204,0 
DB 170,0,0,136 
DB 170,0,0,136 
DB 0,0,0,68 
DB 0,0,0,68 

CLOUD_TL:
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,162 
DB 243,243,243,85 
DB 243,243,162,255 
DB 243,243,162,255 
DB 243,243,162,255 
DB 243,243,162,255 
DB 243,243,85,235 
DB 243,243,85,215 
DB 243,0,255,255 
DB 243,85,255,255 
DB 162,255,255,255 
DB 162,255,255,255 
DB 85,255,255,255 

CLOUD_TR:
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 81,243,243,243 
DB 170,243,243,243 
DB 170,243,243,243 
DB 255,81,243,243 
DB 255,81,243,243 
DB 215,170,243,243 
DB 235,170,243,243 
DB 255,170,243,243 
DB 255,170,243,243 
DB 255,255,81,243 
DB 255,255,170,243 
DB 255,255,170,81 
DB 255,255,255,170 

CLOUD_BL:
DB 85,255,255,255 
DB 85,255,255,255 
DB 85,255,255,255 
DB 162,255,255,255 
DB 162,235,255,255 
DB 243,85,215,235 
DB 243,85,235,195 
DB 243,162,255,215 
DB 243,243,85,255 
DB 243,243,85,170 
DB 243,243,162,81 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 

CLOUD_BR:
DB 255,255,255,170 
DB 255,255,255,170 
DB 255,255,255,170 
DB 215,255,255,81 
DB 255,255,255,170 
DB 215,235,255,170 
DB 195,215,255,81 
DB 235,215,255,170 
DB 255,255,170,81 
DB 85,170,81,243 
DB 162,81,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 
DB 243,243,243,243 


'END